#ifndef VMS_H
#define VMS_H

#include <stat.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <types.h>

#define __attribute__(str)
#define socklen_t int
#define SIZE_MAX 4294967295u

void arglist (char*, char*[]);
int chroot(const char*);
char* exctrl (char*, int);
int fork();
int furk(char*, char**);
char* fdid (int);
void fdlist(int, const char*);
char* getprogname();
void* memmem(const void*, size_t, const void*, size_t);
int pledge (const char*, const char*);
void* reallocarray (void*, int, int);
void* recallocarray (void*, size_t, size_t, size_t);
int refd (int, int);
int setgroups (int size, void *gid_t);
int setegid (unsigned int);
char *strsignal (int);
char* strndup(const char*, size_t);
char *tstamp (ulong*);
int unveil (const char*, const char*);
void vmsdbg (char *fmt, ...);
int pairofsockets (int[]);

void verr (const char *format, va_list ap);
void verrx (const char *format, va_list ap);
void err (int, const char *fmt, ...);
void errx (int, const char *fmt, ...);
void vwarn (const char *format, va_list ap);
void vwarnx (const char *format, va_list ap);
void warn (const char *fmt, ...);
void warnx (const char *fmt, ...);

size_t strlcpy(char *dst, const char *src, size_t siz);
size_t strlcat(char *dst, const char *src, size_t siz);

void freezero (void*, int);

int getline(char **buf, int *bufsiz, FILE *fp);

/* SYSPRV enabled before file access */
int wrap_chdir (const char*, ...);
int wrap_creat (const char*, mode_t, ...);
FILE* wrap_fdopen (int, const char*);
FILE* wrap_fopen (const char*, const char*);
int wrap_open (const char*, int, ...);
int wrap_fstat (int, struct stat*);
int wrap_unlink (const char*);

/* redefine standard C-RTL functiomn names to "wrap_" equivalent */
#define access wrap_access
#define chdir wrap_chdir
#define creat wrap_creat
#define fdopen wrap_fdopen
#define fopen wrap_fopen
#define fstat wrap_fstat
#define open wrap_open
#define rename wrap_rename
#define unlink wrap_unlink

char* UtilOds2FileName (char*, char*, char*);

#endif /* VMS_H */
